<template>
  <div class="home">
    <b-button v-b-modal.modal-start>Start New Game</b-button>

    <b-modal
      id="modal-start"
      title="Start New Game"
      @show="resetModal"
      @hidden="resetModal"
      @ok="handleOk"
    >
      <form ref="startForm" @submit.stop.prevent="handleSubmit">
        <b-form-group
          horizontal
          :label-cols="4"
          :state="nameState"
          description="Let us know your name."
          label="Enter your name"
          invalid-feedback="Name is required"
        >
          <b-form-input v-model.trim="name" :state="nameState" required></b-form-input>
        </b-form-group>
      </form>
    </b-modal>

    <b-alert variant="success" :show="showAlert">Hello {{ name }}</b-alert>
  </div>
</template>

<script>
import * as fb from "@/firebase";

export default {
  data() {
    return {
      name: "",
      nameState: null
    };
  },
  computed: {
    showAlert() {
      return this.name.length > 4 ? true : false;
    }
  },
  methods: {
    checkFormValidity() {
      const valid = this.$refs.startForm.checkValidity();
      this.nameState = valid;
      return valid;
    },
    resetModal() {
      this.name = "";
      this.nameState = null;
    },
    handleOk(bvModalEvt) {
      // Prevent modal from closing
      bvModalEvt.preventDefault();
      // Trigger submit handler
      this.handleSubmit();
    },
    handleSubmit() {
      // Exit when the form isn't valid
      if (!this.checkFormValidity()) {
        return;
      }

      const gameId = Math.random().toString(36).substring(2, 15) + Math.random().toString(36).substring(2, 15);
      console.log(gameId)

      fb.db
        .collection("games")
        .doc(gameId)
        .set({ players: [this.name] })
        .then(doc => {
          this.$bvModal.hide("modal-start");
          this.$router.push({ name: "Game", params: { id: doc.id } });
        });
    }
  }
};
</script>
